;==================================
; Cars by Cullen Sauls
; My first ASM game =)
; Last Updated: 2-8-99
; Webpage: http://freeweb.pdq.net/sauls1/
; E-Mail: sauls1@pdq.net
; ICQ: 11130342
;
; IMPORTANT: This game was made by ME! You are allowed to take pieces of it, but you are NOT allowed
;            to make changes and distribute a modified source. Any and all changes should be for PERSONAL
;			 USE. If you do change the source code, pleaze tell me what and why.
;==================================


#include "asm86.h"                       ;Standard Include Files
#include "ti86asm.inc"					 ;"

.org _asm_exec_ram                       ;Every Program Starts With This

;--- Commentation For Shell ---

	nop									 ;identifier for comment/icon
	jp Start
	.dw 1								 ;note this is version 1 of the table
										 ;0 means just a comment
	.dw title							 ;pointer to title
	.dw icon							 ;pointer to icon

;---

Start:
	call BUSY_OFF              			 ;God I Hate That Thing!

	call _clrLCD                         ;Clear The LCD

	ld hl,TitleScreen                    ;Load TitleScreen Into HL
	call DrawMap                         ;Draw The Title Screen Tile Map

	ld hl,$202A                          ;Sets Pen Cursor To (42,32)
	ld (_penCol),hl                      ;"
	ld hl,Version                        ;Load Sting Version Into HL
	call _vputs                          ;Show It Menu Style (Small Font)

	ld hl,$0005                          ;Set Cursor To (5,0)
	ld (_curRow),hl                      ;"
	ld hl,MadeBy                         ;Load String MadeBy Into HL
	call _puts                           ;Show It!

	ld hl,$3A0C                          ;Sets Pen Cursor To (12,58)
	ld (_penCol),hl                      ;"
	ld hl,Webpage                        ;Load Sting Webpage Into HL
	call _vputs                          ;Show It Menu Style (Small Font)

	ld a,5                               ;Load (5,0) Into BC
	ld b,a                               ;"
	ld a,0                               ;"
	ld c,a                               ;"
	ld de,Car                            ;Load Car Sprite Into DE
	call PutSprite                       ;Show It!

	ld a,5                               ;Load (5,15) Into BC
	ld b,a                               ;"
	ld a,15                              ;"
	ld c,a                               ;"
	ld de,Car                            ;Load Car Sprite Into DE
	call PutSprite                       ;Show It!

	call WaitForEnterOrSecond			 ;Call WaitForEnterOrSecond

BeginGame:                               ;Get Speed And Setup

	ld hl,0                              ;Set Score To 0
	ld (Score),hl                        ;"

	ld a,5                               ;Set All Sides To 5
	ld (wall_1),a                        ;"
	ld (wall_2),a                        ;"
	ld (wall_3),a                        ;"
	ld (wall_4),a                        ;"
	ld (wall_5),a                        ;"
	ld (wall_6),a                        ;"
	ld (wall_7),a                        ;"
	ld (wall_8),a                        ;"
	ld a,8                               ;Set Car's X Position At 8
	ld (CarX),a                          ;"

	ld hl,SpeedTable					 ;Load SpeedTable Into HL

	jp DoMenu							 ;Goto DoMenu

Slowest:								 ;Set Speed To Slowest
	ld a,5								 ;Load 5 Into A
	ld (Speed),a						 ;Load A Into Speed
	jr MakeScreenBlack					 ;Go To ShowTrack

Slow:									 ;Set Speed To Slow
	ld a,4								 ;Load 4 Into A
	ld (Speed),a						 ;Load A Into Speed
	jr MakeScreenBlack					 ;Go To ShowTrack

Normal:									 ;Set Speed To Normal
	ld a,3								 ;Load 3 Into A
	ld (Speed),a						 ;Load A Into Speed
	jr MakeScreenBlack					 ;Go To ShowTrack

Fast:									 ;Set Speed To Fast
	ld a,2								 ;Load 2 Into A
	ld (Speed),a						 ;Load A Into Speed
	jr MakeScreenBlack					 ;Go To ShowTrack

Fastest:								 ;Set Speed To Fastest
	ld a,1								 ;Load 1 Into A
	ld (Speed),a						 ;Load A Into Speed
	jr MakeScreenBlack					 ;Go To ShowTrack

MakeScreenBlack:						 ;Makes The Screen Black

    ld hl,$fc00      					 ;Point To The Video Memory 
    ld a,%11111111   					 ;Here Is The Line We Want To Draw 
    ld (hl),a        					 ;Draw It! 
	ld de,1								 ;Load 1 Into DE (Makes Vid-Mem Increase By 1 Byte)
	ld c,64								 ;Load 64 Into C (Will Make 64 Horizontal Lines)
LLoop:
	ld b,16								 ;There Are 16 Bytes Per Row
    ld a,%11111111   					 ;Here Is The Line We Want To Draw 
Loop:
    add hl,de        					 ;We Want To Add 1 So We Draw One Column Over 
    ld (hl),a           				 ;Draw It
    djnz Loop        					 ;B=B-1; JP To Loop Until B=0 
	dec c								 ;Decrease C
	ld a,c								 ;Load C Into A
	cp 0								 ;Check If C Is 0
	jr nz,LLoop							 ;If Not, Goto LLoop To Draw To Next Row

GameStart:                               ;Yay! Game Finally Starts

	ld a,7                               ;Load A With 7
	ld b,a                               ;Load B With A
	ld a,(CarX)                          ;Load A With CarX
	ld c,a                               ;Load C With A
	ld de,Car                            ;Load Car Sprite Into DE
	call PutSprite                       ;Show It!

	call GET_KEY                         ;Read Key Presses
	cp K_EXIT                            ;Was Exit Pressed?
	jp z,End                             ;If So, Go To End
	cp K_MORE                            ;Was More Pressed?
	call z,Pause                         ;If So, Call Pause
	cp K_RIGHT                           ;Was Right Arrow Pressed?
	call z,MoveRight                     ;If So, Call MoveRight
	cp K_LEFT                            ;Was Left Arrow Pressed?
	call z,MoveLeft                      ;If So, Call MoveLeft

	ld b,8								 ;I Want To Make 8 Road Lines

;--- Draw Roads ---

DrawRoads:								 ;Draws All The Roads

	ld a,b								 ;Load B Into A
	cp 8								 ;Is It Going To Draw Line 8?
	jp z,Load8							 ;If So, Go To Load8
	cp 7								 ;Is It Going To Draw Line 7?
	jp z,Load7							 ;If So, Go To Load7
	cp 6								 ;Is It Going To Draw Line 6?
	jp z,Load6							 ;If So, Go To Load6
	cp 5								 ;Is It Going To Draw Line 5?
	jp z,Load5							 ;If So, Go To Load5
	cp 4								 ;Is It Going To Draw Line 4?
	jp z,Load4							 ;If So, Go To Load4
	cp 3								 ;Is It Going To Draw Line 3?
	jp z,Load3							 ;If So, Go To Load3
	cp 2								 ;Is It Going To Draw Line 2?
	jp z,Load2							 ;If So, Go To Load2
	cp 1								 ;Is It Going To Draw Line 1?
	jp z,Load1							 ;If So, Go To Load1
ReturnHere:								 ;Load1-8 Will Return Here
	dec b								 ;Decrease B Cause Screen Starts At 0, Not 1
	ld c,a                               ;Load C With A
	ld de,Side                           ;Load Side Sprite Into DE
	push bc								 ;Save B Cause PutSprite Destroys It
	push af								 ;Save A Cause PutSprite Destroys It
	call PutSprite                       ;Show It!
	pop af								 ;Restore A
	pop bc								 ;Restore B

	inc a                                ;Increase A By 1
	ld c,a                               ;Load C With A
	ld de,Road                           ;Load Road Sprite Into DE
	push bc								 ;Save B Cause PutSprite Destroys It
	push af								 ;Save A Cause PutSprite Destroys It
	call PutSprite                       ;Show It!
	pop af								 ;Restore A
	pop bc								 ;Restore B

	inc a                                ;Increase A By 1
	ld c,a                               ;Load C With A
	ld de,Road                           ;Load Road Sprite Into DE
	push bc								 ;Save B Cause PutSprite Destroys It
	push af								 ;Save A Cause PutSprite Destroys It
	call PutSprite                       ;Show It!
	pop af								 ;Restore A
	pop bc								 ;Restore B

	inc a                                ;Increase A By 1
	ld c,a                               ;Load C With A
	ld de,Road                           ;Load Road Sprite Into DE
	push bc								 ;Save B Cause PutSprite Destroys It
	push af								 ;Save A Cause PutSprite Destroys It
	call PutSprite                       ;Show It!
	pop af								 ;Restore A
	pop bc								 ;Restore B

	inc a                                ;Increase A By 1
	ld c,a                               ;Load C With A
	ld de,Road                           ;Load Road Sprite Into DE
	push bc								 ;Save B Cause PutSprite Destroys It
	push af								 ;Save A Cause PutSprite Destroys It
	call PutSprite                       ;Show It!
	pop af								 ;Restore A
	pop bc								 ;Restore B

	inc a                                ;Increase A By 1
	ld c,a                               ;Load C With A
	ld de,Road                           ;Load Road Sprite Into DE
	push bc								 ;Save B Cause PutSprite Destroys It
	push af								 ;Save A Cause PutSprite Destroys It
	call PutSprite                       ;Show It!
	pop af								 ;Restore A
	pop bc								 ;Restore B

	inc a                                ;Increase A By 1
	ld c,a                               ;Load C With A
	ld de,Side                           ;Load Side2 Sprite Into DE
	push bc								 ;Save B Cause PutSprite Destroys It
	push af								 ;Save A Cause PutSprite Destroys It
	call PutSprite                       ;Show It!
	pop af								 ;Restore A
	pop bc								 ;Restore B
	inc b								 ;Increase B To get Right Value
	djnz DrawRoads						 ;Decrease B, And If B=0, Conctinue, Otherwise, Go To DrawRoads

;---

;--- Shows Your Score In Upper Left ---

	ld hl,$0000							 ;Set PenCol To Upper Left
	ld (_penCol),hl						 ;"
	ld hl,Score							 ;Load Score Value Into HL
	call LD_HL_MHL						 ;Dunno What This Does, The DM_HL_Deci Routine Was Yanked From ZTetris By Jimmy Mardell
	ld b,5								 ;Want It To Print 5 Didgets With Leading 0's
	call DM_HL_Deci						 ;Show It Menu Style (Small Font)

;---

	ld a,7                               ;Load A With 7
	ld b,a                               ;Load B With A
	ld a,(CarX)                          ;Load A With CarX
	ld c,a                               ;Load C With A
	ld de,Car                            ;Load Car Sprite Into DE
	call PutSprite                       ;Show It!

AreYouDead:                              ;Checks If You Have Crashed
	ld a,(CarX)                          ;Load A With CarX
	ld b,a                               ;Load B With A
	ld a,(wall_8)                        ;Load A With wall_8
	cp b                                 ;See If You Hit Left Side
	jp z,IsDead                          ;If So, You Are Dead =(
	inc a                                ;Increase A By 1
	inc a                                ;Increase A By 1
	inc a                                ;Increase A By 1
	inc a                                ;Increase A By 1
	inc a                                ;Increase A By 1
	inc a                                ;Increase A By 1
	cp b                                 ;See If You Hit Right Side
	jp z,IsDead                          ;If So, You Are Dead =(

    ld hl,(Score)
    inc hl
    ld (Score),hl

;Routine Put In Twice To Make Game Easier (Car Moves Better). Can Be Commented Out To Add Difficulty.

	call GET_KEY                         ;Read Key Presses
	cp K_EXIT                            ;Was Exit Pressed?
	jp z,End                             ;If So, Go To End
	cp K_MORE                            ;Was More Pressed?
	call z,Pause                         ;If So, Call Pause
	cp K_RIGHT                           ;Was Right Arrow Pressed?
	call z,MoveRight                     ;If So, Call MoveRight
	cp K_LEFT                            ;Was Left Arrow Pressed?
	call z,MoveLeft                      ;If So, Call MoveLeft

	call Scroll                          ;Call Scroll Routine

	call SpeedOfGame					 ;Call SpeedOfGame

	jp GameStart                         ;Go Back To GameStart And Begin Loop Again

;==================================
; Subroutines
;==================================

SpeedOfGame:							 ;Get The Game Speed
	ld a,(Speed)						 ;Load Speed Into A
SpeedLoop:								 ;Loop To Slow Game Appropiately
	halt								 ;Slow Game
	dec a								 ;Decrease A
	jr nz,SpeedLoop						 ;Go To SpeedLoop If A != 0
	ret 								 ;Return To Game

Load8:									 ;Loads wall_8 Value Into A And Returns To ReturnHere
	ld a,(wall_8)						 ;"
	jp ReturnHere						 ;"
Load7:									 ;Loads wall_7 Value Into A And Returns To ReturnHere
	ld a,(wall_7)						 ;"
	jp ReturnHere						 ;"
Load6:									 ;Loads wall_6 Value Into A And Returns To ReturnHere
	ld a,(wall_6)						 ;"
	jp ReturnHere						 ;"
Load5:									 ;Loads wall_5 Value Into A And Returns To ReturnHere
	ld a,(wall_5)						 ;"
	jp ReturnHere						 ;"
Load4:									 ;Loads wall_4 Value Into A And Returns To ReturnHere
	ld a,(wall_4)						 ;"
	jp ReturnHere						 ;"
Load3:									 ;Loads wall_3 Value Into A And Returns To ReturnHere
	ld a,(wall_3)						 ;"
	jp ReturnHere						 ;"
Load2:									 ;Loads wall_2 Value Into A And Returns To ReturnHere
	ld a,(wall_2)						 ;"
	jp ReturnHere						 ;"
Load1:									 ;Loads wall_1 Value Into A And Returns To ReturnHere
	ld a,(wall_1)						 ;"
	jp ReturnHere						 ;"

IsDead:                                  ;Executed If You Crash

	call _clrLCD                         ;Clear The LCD

	ld hl,$0000                          ;Set Cursor Coords To (0,0)
	ld (_curRow),hl                      ;"
	ld hl,YouDied                        ;Load The String YouDied Into HL
	call _puts                           ;Show It!

	ld hl,$151F							 ;Sets PenCol To (31,21)
	ld (_penCol),hl						 ;"
	ld hl,FinalScore					 ;Load String FinalScore Into HL
	call _vputs							 ;Display It Menu Style (Small Font)

	ld hl,$154D							 ;Set PenCol To (77,21)
	ld (_penCol),hl						 ;"
	ld hl,Score							 ;Load Your Score Into HL
	call LD_HL_MHL						 ;Dunno What This Does, The DM_HL_Deci Routine Was Yanked From ZTetris By Jimmy Mardell
	ld b,5								 ;Want To Show 5 Didgets With Leading 0's
	call DM_HL_Deci						 ;Show It Menu Style (Small Font)

	ld hl,$0004                          ;Set The Cursor Coords To (4,0)
	ld (_curRow),hl                      ;"
	ld hl,PlayAgain                      ;Load The String PlayAgain Into HL
	call _puts                           ;Show It!

	ld hl,(HighScore)					 ;Load The Current High Score Into HL
	ld de,(Score)						 ;Load Your Score Into DE
	call CP_HL_DE						 ;Compare HL And DE
	jr nc,NotHighScore					 ;If Your Score Is Not Higher, Go To NotHighScore

NewHighScore:							 ;You Beat The Current High Score!

	set 3,(IY+05)						 ;Set Text The White On Black

	ld hl,$0000							 ;Set Cursor To (0,0)
	ld (_curRow),hl						 ;"
	ld hl,NewHigh						 ;Load The String NewHigh Into HL
	call _puts							 ;Show It!

	res 3,(IY+05)						 ;Reset Text To Black On White

	ld hl,(Score)						 ;Load Your Score Into HL
	ld (HighScore),hl					 ;Make Your Score The New High Score

	call SaveHigh						 ;Save It!

NotHighScore:							 ;Asks You To Play Again
WaitForAnswer:                           ;Waits For Users Answer To Question

	call GET_KEY                         ;Read Key Presses
	cp K_F1                              ;Was F1 Pressed?
	jp z,BeginGame                       ;If So, Play Game Again
	cp K_F2                              ;Was F2 Pressed?
	jr z,End                             ;If So, Quit Game
	jr nz,WaitForAnswer                  ;If Neither 1 Or 2 Was Pressed, Go To WaitForAnswer

WaitForEnterOrSecond:                    ;Waits For The User To Press Enter Or 2ND
	call GET_KEY                         ;Reads Key Presses
	cp K_ENTER                           ;Was Enter Pressed?
	ret z                                ;If So, Return To Game
	cp K_SECOND							 ;Was 2nd Pressed?
	ret z								 ;If So, Return To Game
	jr WaitForEnterOrSecond				 ;If Neither Were Pressed, Go To WaitForEnterOrSecond

End:                                     ;Ends The Game

static_on:                               ;Static Routine By Macross Software
	ld b, 255                            ;I Have No Idea How It Works Right Now =P
ClearSplit:                              ;"
	push bc                              ;"
	LD a, r                              ;"
	LD h, a                              ;"
	LD a, r                              ;"
	LD l, a                              ;"
	LD de, VIDEO_MEM                     ;"
	LD bc, 1024                          ;"
	ldir                                 ;"
	pop bc                               ;"
	djnz ClearSplit                      ;"

	set 3,(IY+05)                        ;Set Text To White On Black

	call _clrLCD                         ;Clear The LCD
	ld hl,$0000                          ;Set Cursor Coords To (0,0)
	ld (_curRow),hl                      ;"
	ld hl,Programmed                     ;Load The String Programmed Into HL
	call _puts                           ;Show It!

	res 3,(IY+05)                        ;Reset Text Back To Black On White

	ld hl,$0002                          ;Set Cursor Coords To (2,0)
	ld (_curRow),hl                      ;"
	ld hl,Blank                          ;Load The String Blank Into HL
	call _puts                           ;Show It!

	call (_getkey)                       ;Wait For Any Key To Be Pressed	

	call _clrLCD						 ;Clears The Screen

	ret                                  ;Quit Program, Return To Shell/Normal OS

Pause:                                   ;Called If Game Is Paused
	ld hl,$0000                          ;Set Cursor Coords To (0,0)
	ld (_curRow),hl                      ;"
	ld hl,Paused                         ;Load The String Paused Into HL
	call _puts                           ;Show It!

PauseForMore:                            ;Waits For User To Press More Key
	call GET_KEY                         ;Reads Key Presses
	cp K_MORE                            ;Was More Pressed?
	jr nz,PauseForMore                   ;If It Wasn't, Go To PauseForMore
	set 3,(IY+05)                        ;Set Text To White On Black
	ld hl,$0000                          ;Set Cursor Coords To (0,0)
	ld (_curRow),hl                      ;"
	ld hl,Blank                          ;Load The String Blank Into HL
	call _puts                           ;Show It!
	res 3,(IY+05)                        ;Reset Text To Black On White

;Gets Rid Of Small White Sliver In Upper Right Of Screen

	ld a,0                               ;Load 0 Into A
	ld b,a                               ;Load A Into B
	ld a,15                              ;Load 15 Into A
	ld c,a                               ;Load A Into C
	ld de,Side                           ;Load The Side Sprite Into DE
	call PutSprite                       ;Show It!
	ret                                  ;Return To Game

MoveRight:                               ;Move Car Right
	ld a,(CarX)                          ;Load CarX Into A
	cp 15                                ;Is The Car At Far-Right Already?
	jp z,GameStart                       ;If So, Return To Game
	ld a,(CarX)                          ;Load CarX Into A
	inc a                                ;Increase A By 1
	ld (CarX),a                          ;Load A Into CarX
	ret                                  ;Return To Game

MoveLeft:                                ;Move Car Left
	ld a,(CarX)                          ;Load CarX Into A
	cp 0                                 ;Is The Car At Far-Left Already?
	jp z,GameStart                       ;If So, Return To Game
	ld a,(CarX)                          ;Load CarX Into A
	dec a                                ;Decrease A By 1
	ld (CarX),a                          ;Load A Into CarX
	ret                                  ;Return To Game

Scroll:                                  ;Moves The Road Down
	ld a,(wall_7)                        ;Load wall_7 Into wall_8
	ld (wall_8),a                        ;"
	ld a,(wall_6)                        ;Load wall_6 Into wall_7
	ld (wall_7),a                        ;"
	ld a,(wall_5)                        ;Load wall_5 Into wall_6
	ld (wall_6),a                        ;"
	ld a,(wall_4)                        ;Load wall_4 Into wall_5
	ld (wall_5),a                        ;"
	ld a,(wall_3)                        ;Load wall_3 Into wall_4
	ld (wall_4),a                        ;"
	ld a,(wall_2)                        ;Load wall_2 Into wall_3
	ld (wall_3),a                        ;"
	ld a,(wall_1)                        ;Load wall_1 Into wall_2
	ld (wall_2),a

GetRand                                  ;Ahmed El-Helw's random routine
	call    _RANDOM                      ;I'm not sure how it works :)
	ld      a,7                          ;"
	call    _setxxop2                    ;"
	call    _fpmult                      ;"
	call    _convop1                     ;"
	ld      a,e                          ;"

	cp 1                                 ;Was The Random Number 1?
	jr z,Left                            ;If So, Go To Left
	cp 2                                 ;Was The Random Number 2?
	jr z,Left                            ;If So, Go To Left
	cp 3                                 ;Was The Random Number 3?
	jr z,Left                            ;If So, Go To Left
	cp 4                                 ;Was The Random Number 4?
	jr z,Right                           ;If So, Go To Right
	cp 5                                 ;Was The Random Number 5?
	jr z,Right                           ;If So, Go To Right
	cp 6                                 ;Was The Random Number 6?
	jr z,Right                           ;If So, Go To Right
	ret nz                               ;If None Of The Above, Road Continues Straight

Left:                                    ;Road Turns Left
	ld a,(wall_1)                        ;Load A With wall_1
	cp 0                                 ;Is Road Already At Far-Left?
	ret z                                ;If So, Return To Game
	ld a,(wall_1)                        ;Load A With wall_1
	dec a                                ;Decrease A By 1
	ld (wall_1),a                        ;Load wall_1 With A
	ret                                  ;Return To Game

Right:                                   ;Road Turns Right
	ld a,(wall_1)                        ;Load A With wall_1
	cp 9                                 ;Is Road Already At Far-Right?
	ret z                                ;If So, Return To Game
	ld a,(wall_1)                        ;Load A With wall_1
	inc a                                ;Increase A By 1
	ld (wall_1),a                        ;Load wall_1 With A
	ret                                  ;Return To Game

DM_HL_Deci:	       						 ;Display HL In Menu Style With Leading Zeros
	ld de,String+5						 ;Routine Taken From ZTetris By Jimmy Mardell, No Idea How It Works
	xor a
	ld (de),a
RepUnp:
	dec de
	call UNPACK_HL
	add a,48
	ld (de),a
	djnz RepUnp
	ex de,hl
	jp _vputs

;--- SaveHigh Was Taken From ZTetris Also, But Slightly Modified ---

SaveHigh:								 ;Saves The New High Score
 ld hl,ProgName        					 ;All This Stuff Is To Make Sure The Hiscore Table
 rst 20h								 ;And Resume Stuff Are Stored In The Variable
 rst 10h
 ex de,hl								 ;HL -> Start Of Variable
 ld a,b
 ld de,HighScore-$D748+4				 ;DE = Relative Offset To Stuff To Store (-4)
 add hl,de
 adc a,0								 ;Next Block If Necessary
 ld de,HighScore	       				 ;DE = Start Of Bytes To Copy
 ld b,2	       							 ;2 Bytes To Copy
RepCopy:
 push af
 push hl
 call $46C3
 ld a,(de)								 ;Read
 ld (hl),a								 ;And Save It In The Real Variable
 pop hl
 pop af
 call $4637
 inc de
 djnz RepCopy
 ret

;---

;==================================
; DrawMap -- Draws An 8x16 Tilemap  [Assembly Coder's Zenith]
; Input: HL = Pointer To Tilemap To Draw
; Total: 34b/91529t (Including Ret And Entire GridPutSprite)
;==================================
DrawMap:
	ld de,$0000            				 ;Start Drawing At (0, 0)
DrawMapL:
	push hl                				 ;Save Map Pointer
	ld l,(hl)              				 ;Get The Current Tile
	ld h,0                 				 ;Clear The Upper Byte
	add hl,hl              				 ;Multiply By 8 (* 2)
	add hl,hl             				 ;* 4
	add hl,hl            				 ;* 8
	ld bc,Sprites        				 ;Load The Start Of The Sprites
	add hl,bc            				 ;Add Togehter To Get Correct Sprite
	push de              				 ;Save Sprite Draw Location
	call GridPutSprite   				 ;Draw The Sprite
	pop de               				 ;Restore Sprite Draw Location
	pop hl               				 ;Restore Map Pointer
	inc hl               				 ;Go To Next Tile
	inc e                				 ;Move Location To The Right
	bit 4,e              				 ;If The 5th Bit (E = 16), We're Done
	jr z,DrawMapL        				 ;Only Jump If The Row Isn't Complete
	ld e,0               				 ;Draw At The Left Again
	inc d                				 ;Move Location Down A Row
	bit 3,d              				 ;Check If It's Done (E = 8)
	ret nz               				 ;Return If We're Done
	jr DrawMapL          				 ;Jump Back To The Top Of The Loop

;==================================
; DoMenu Routine By ACZ Coders Electrum and zoomBlock
;==================================

DoMenu:

	push hl								 ;_clrLCD Destroys HL

	call _clrLCD						 ;Clears The Screen


;--- This Was Added By Me To Show The High Score While You Choose Your Speed ---

	ld hl,$3A29							 ;Set PenCol To (39,55)
	ld (_penCol),hl						 ;"
	ld hl,HiScrStr						 ;Loads The String HiScrStr Into HL
	call _vputs							 ;Show It Menu Style (Small Font)

	ld hl,$3A61							 ;Set PenCol To (97,58)
	ld (_penCol),hl						 ;"
	ld hl,HighScore						 ;Load HighScore Into HL
	call LD_HL_MHL						 ;Still Dunno What This Does
	ld b,5								 ;I Want 5 Didgets With Leading 0's
	call DM_HL_Deci						 ;Show It Menu Style (Small Font)

;---

	pop hl								 ;Now Restore It

	ld c,(hl)							 ;Get Number Of Entries

	inc hl						   		 ;Move To Menu Title Text

	ld de,$0001							 ;Draw At Top, One Char Right

	ld	(_penCol),de					 ;Set The Small Font Coords

	call _vputs							 ;Print The Title Text

	push hl								 ;Save Pointer

	ld hl,$fc00							 ;Point To Video Ram

	call DoMenuInv				     	 ;Invert The Top Line

	pop hl								 ;Restore Our Pointer

	ld b,c								 ;Load Num Entries For Loop

	ld de,$0729							 ;Start Printing At Middle Of Second Line

DoMenuDTL:

	ld (_penCol),de						 ;Set The Font Coords

	call _vputs							 ;Print The Menu Text

	ld a,d								 ;Get The Vertical Coord

	add a,7								 ;Move To Next Line

	ld d,a								 ;Save New Coord

	djnz DoMenuDTL						 ;Draw All The Text

	push hl 							 ;Save Pointer

	ld b,1								 ;Start Menu At First Entry

	call DoMenuInvBar					 ;Invert It

DoMenuL:

	push bc								 ;Save Entries And Current Entry

	call GET_KEY						 ;Read Key Presses

	pop bc								 ;Restore It
	cp K_UP								 ;Did They Press Up?

	jr z,DoMenuUp						 ;Move Menu Bar Up

	cp K_DOWN							 ;Or Was It Down?

	jr z,DoMenuDown						 ;Then Move The Bar Down

	cp K_SECOND							 ;Did They Hit 2nd?

	jr z,DoMenuSelect					 ;Then They Want It

	cp K_ENTER							 ;Some People Like Enter

	jr z,DoMenuSelect					 ;So Check It Too

	jr DoMenuL							 ;They're Just Sitting There, Loop Again

DoMenuUp:

	call DoMenuInvBar					 ;Invert Current Selection Back To Normal

	dec b								 ;Move Up

	jr nz,DoMenuBar						 ;If It's Zero, We're At The Top

	ld b,c								 ;So Move To The Bottom

	jr DoMenuBar						 ;Handle Menu Bar

DoMenuDown:

	call DoMenuInvBar					 ;Same As Up, Go Back To Normal Text

	ld a,c								 ;Get Current Entry For Check

	cp b								 ;At The Bottom?

	jr z,DoMenuDownT					 ;Then Move To The Top

	inc b								 ;Move Down

	jr DoMenuBar						 ;Handle Menu Bar

DoMenuDownT:

	ld b,1								 ;Move To The Top

DoMenuBar:

	call DoMenuInvBar					 ;Invert The New Selection

	jr DoMenuL							 ;Now It's Time To Loop

DoMenuInvBar:

	push hl					 			 ;Save Pointer

	push bc								 ;Save Position And Entries

	ld h,b								 ;Get Position

	ld l,112							 ;There Are 7 Lines Of 16 Bytes Each (7*16 = 112)

	call MUL_HL							 ;Do The Multiply

	ld de,$fc00							 ;We Need To Add To Video Memory

	add hl,de							 ;Do The Add

	call DoMenuInv						 ;Invert The Line

	pop bc								 ;Restore Position And Entries

	pop hl								 ;Restore Pointer

	ret									 ;Done Inverting

DoMenuInv:

	ld b,7*16							 ;Each Row Is 16 Bytes Wide And Text Is 7 Rows High

DoMenuIL:

	ld a,(hl)							 ;Get The Byte

	cpl						 			 ;NOT The Byte--Flips All The Bits

	ld (hl),a							 ;Save The New Byte

	inc hl								 ;Next Byte

	djnz DoMenuIL						 ;Loop For All Bytes

	ret						 			 ;We're Done With The Invert Loop

DoMenuSelect:

	pop hl								 ;Restore The Pointer

	ld d,0								 ;Clear Upper Byte

	ld e,b								 ;Load Lower Byte With Current Selection

	dec e								 ;Decrease, Starting At 0 Instead Of 1

	sla e								 ;Multiply By 2, Pointers Are 16-bit (2 Bytes)

	add hl,de							 ;Add To Get Correct Address In The Jump Table

	ld a,(hl)				       		 ;Get Lower Byte Of Pointer

	inc hl								 ;Next Byte

	ld h,(hl)							 ;Get Upper Byte Of Pointer

	ld l,a								 ;Complete Pointer With Lower Byte

	jp (hl)						 	 	 ;Jump To The Address From The Table--HL, not (HL)

;==================================
; GridPutSprite: [Routine By Dan Eble]
; Puts An Aligned Sprite At (E, D), Where HL -> Sprite
;==================================
; IN : D  = y (0-7 Inclusive)
;      E  = x (0-15 Inclusive)
;      HL -> Sprite
;
; OUT: AF, BC, DE, HL, IX Modified
; Current Total : 28b/567t (Not Counting Ret)
;==================================
GridPutSprite:
	push hl
	pop ix								 ;IX -> Sprite
	srl d          						 ;DE = 128y+x (16 Bytes/Row, 8 Rows)
	rra
	and $80
	or e           						 ;Add x Offset (Remember x <= 15)
	ld e,a
	ld hl,$fc00            				 ;HL -> Video Ram
	add hl,de            				 ;HL -> Video Ram + Offset
	ld b,8               				 ;Initialize Loop Counter
	ld de,$10            				 ;Initialize Line Increment
GPS_Loop:
	ld a,(ix+0)    						 ;Get Byte From Sprite
	ld (hl),a      						 ;Put Byte On Screen
	inc ix         						 ;Move To Next Byte In Sprite
	add hl,de     						 ;Move To Next Line On Screen
	djnz GPS_Loop
	ret

;==================================
; Put Sprite
;==================================

PutSprite:
	 push de     						 ;** We Need To Save DE
	 ld hl,$fb80 						 ;Point To The First Byte In Video Memory - 128 Bytes
	 inc b       						 ;B=B+1
	 ld de,$80   						 ;Number Of Bytes Per Line
YCoord:
	 add hl,de
	 djnz YCoord
	 add hl,bc 			  				 ;Now HL Points To VID_MEM + OFFSET
	 pop de   			   				 ;** Now DE Still Points To Pprite
	 ld b,8      		  				 ; Repeat 8 Times
CopySprite:
	 push bc      	   					 ;Save The Counter
	 ld a,(de)    	   					 ;Get One Byte Of Sprite
	 ld (hl),a     	  					 ;Copy It To Video Mem
	 inc de      	   					 ;Point To Next Byte Of Sprite
	 ld bc,16     	   					 ;"
	 add hl,bc       					 ;Offset Vid Mem By 16 Bytes (Go Next Line Down)
	 pop bc          					 ;Get The Counter Back
	 djnz CopySprite 	 				 ;Do The Loop
	 ret             					 ;End Of The Routine

;==================================
; Data For Title Screen
;==================================

TitleScreen:
	 .db $00,$00,$00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$00,$00,$00,$00
	 .db $00,$00,$00,$0A,$0B,$0C,$0D,$0E,$0F,$10,$11,$12,$00,$00,$00,$00
	 .db $00,$00,$00,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$00,$00,$00,$00
	 .db $00,$00,$00,$1C,$1D,$1E,$1F,$20,$21,$22,$23,$24,$00,$00,$00,$00
	 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

;==================================
; Strings
;==================================

MadeBy:
	.db "   By Cullen Sauls   "
	.db "   sauls1@pdq.net",0
Webpage:
	.db "http://freeweb.pdq.net/sauls1",0
Version:
	.db "Version    1.4",0
Paused:
	.db "Paused               ",0
Blank:
	.db "                     ",0
NewHigh:
	.db "  Congratulations!!  "
	.db "  A New High Score!  ",0
YouDied:
	.db "     You Crashed",0
FinalScore:
	.db "Final Score:",0
PlayAgain:
	.db "     Play Again?     "
	.db "       F1: Yes       "
	.db "       F2: No",0
Programmed:
	.db "    Programmed by    "
	.db "    Cullen  Sauls    ",0
HiScrStr:
	.db "High Score:",0

;==================================
; Variables
;==================================

wall_1        = $CFAC                    ;Variable For Line 1 Road
wall_2        = $CFAD                    ;Variable For Line 2 Road
wall_3        = $CFAE                    ;Variable For Line 3 Road
wall_4        = $CFAF                    ;Variable For Line 4 Road
wall_5        = $CFB0                    ;Variable For Line 5 Road
wall_6        = $CFB1                    ;Variable For Line 6 Road
wall_7        = $CFB2                    ;Variable For line 7 Road
wall_8        = $CFB3                    ;Variable For Line 8 Road

String		  = $C126					 ; 6 BYTE

_setxxop2     = $4617   				 ;these are for the random routine
_convop1      = $5577   				 ;"
_fpmult       = $548C   				 ;"

CarX:						.db		0
Speed:						.db		0
Score:						.dw		0

HighScore:					.dw		0
ProgName:					.db 	$12,4,"Cars"

;==================================
; Data For Shell Comments
;==================================

title:
	.db "Cars By Cullen Sauls",0
icon:
	.db 8,1					;this is the height, then the width (in bytes)
	.db %00011000			;then a bitmap
	.db %01011010			;as with comments, this can be placed anywhere
	.db %01111110
	.db %01011010
	.db %00011000
	.db %11011011
	.db %11111111
	.db %11000011

;==================================
; Table Data  {had to change the string commands to .db (were .dw)}
;==================================

SpeedTable:


  .db 5  								 ;num entries

  .db "Choose Your Speed:",0			 ;title text (at the top)

  .db "Wheres the gas?",0		  		 ;text for each entry

  .db "Driving Miss Daisey",0			 ;"
  .db "Freeway",0						 ;"
  .db "Driving Over Miss Daisey",0		 ;"
  .db "Wheres the brake?!",0			 ;"

  .dw Slowest							 ;pointers (labels) to jump

  .dw Slow 								 ;to for each entry in menu
  .dw Normal							 ;"
  .dw Fast								 ;"
  .dw Fastest							 ;"

;==================================
; Sprites   (For Title Screen)
;==================================

Sprites:

Sprite0:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

Sprite1:
	.db %00001111
	.db %00001111
	.db %00001100
	.db %00001100
	.db %00001100
	.db %00001100
	.db %00001101
	.db %00001101

Sprite2:
	.db %11111111
	.db %11111111
	.db %00000000
	.db %00111111
	.db %01111111
	.db %11111111
	.db %11111111
	.db %11111111

Sprite3:
	.db %11111111
	.db %11111111
	.db %00000000
	.db %11111000
	.db %11111000
	.db %11111001
	.db %11111011
	.db %11111011

Sprite4:
	.db %11111111
	.db %11111111
	.db %00000000
	.db %01111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111

Sprite5:
	.db %11111111
	.db %11111111
	.db %00000000
	.db %11000011
	.db %11100011
	.db %11110011
	.db %11111011
	.db %11111011

Sprite6:
	.db %11111111
	.db %11111111
	.db %00000000
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111

Sprite7:
	.db %11111111
	.db %11111111
	.db %00000000
	.db %11000000
	.db %11100000
	.db %11110001
	.db %11111011
	.db %11111011

Sprite8:
	.db %11111111
	.db %11111111
	.db %00000000
	.db %01111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111

Sprite9:
	.db %11111111
	.db %11111111
	.db %00000011
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011

SpriteA:
	.db %00001100
	.db %00001100
	.db %00001100
	.db %00001101
	.db %00001101
	.db %00001101
	.db %00001101
	.db %00001101

SpriteB:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11110000
	.db %11110000
	.db %11110000
	.db %11110000
	.db %11110000

SpriteC:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000011
	.db %00000011
	.db %00000011
	.db %00000011
	.db %00000011

SpriteD:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11100000
	.db %11100000
	.db %11111111
	.db %11111111
	.db %11111111

SpriteE:
	.db %11111000
	.db %11111000
	.db %11111000
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011

SpriteF:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11100000
	.db %11100000
	.db %11111111
	.db %11111111
	.db %11111111

Sprite10:
	.db %11111000
	.db %11111000
	.db %11111000
	.db %11111011
	.db %11111011
	.db %11110011
	.db %11100011
	.db %11000001

Sprite11:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11100000
	.db %11100000
	.db %11111111
	.db %11111111
	.db %11111111

Sprite12:
	.db %00000011
	.db %00000011
	.db %00000011
	.db %00000011
	.db %00000011
	.db %11000011
	.db %11100011
	.db %11110011

Sprite13:
	.db %00001101
	.db %00001101
	.db %00001101
	.db %00001101
	.db %00001101
	.db %00001101
	.db %00001101
	.db %00001101

Sprite14:
	.db %11110000
	.db %11110000
	.db %11110000
	.db %11110000
	.db %11110000
	.db %11110000
	.db %11110000
	.db %11111111

Sprite15:
	.db %00000011
	.db %00000011
	.db %00000011
	.db %00000011
	.db %00000011
	.db %00000011
	.db %00000011
	.db %11111011

Sprite16:
	.db %11111111
	.db %11111111
	.db %11100000
	.db %11100000
	.db %11100000
	.db %11100000
	.db %11100000
	.db %11100000

Sprite17:
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011

Sprite18:
	.db %11111111
	.db %11111111
	.db %11100000
	.db %11100000
	.db %11100000
	.db %11100000
	.db %11100000
	.db %11100000

Sprite19:
	.db %11100000
	.db %11110000
	.db %11111000
	.db %11111000
	.db %11111000
	.db %11111000
	.db %11111000
	.db %11111011

Sprite1A:
	.db %11111111
	.db %01111111
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11111111

Sprite1B:
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011

Sprite1C:
	.db %00001101
	.db %00001100
	.db %00001100
	.db %00001100
	.db %00001100
	.db %00001111
	.db %00001111
	.db %00000000

Sprite1D:
	.db %11111111
	.db %11111111
	.db %01111111
	.db %00111111
	.db %00000000
	.db %11111111
	.db %11111111
	.db %00000000

Sprite1E:
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011
	.db %00000000
	.db %11111111
	.db %11111111
	.db %00000000

Sprite1F:
	.db %11100000
	.db %11100000
	.db %11100000
	.db %11100000
	.db %00000000
	.db %11111111
	.db %11111111
	.db %00000000

Sprite20:
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011
	.db %00000000
	.db %11111111
	.db %11111111
	.db %00000000

Sprite21:
	.db %11100000
	.db %11100000
	.db %11100000
	.db %11100000
	.db %00000000
	.db %11111111
	.db %11111111
	.db %00000000

Sprite22:
	.db %11111011
	.db %11111011
	.db %11111011
	.db %11111011
	.db %00000000
	.db %11111111
	.db %11111111
	.db %00000000

Sprite23:
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %00000000
	.db %11111111
	.db %11111111
	.db %00000000

Sprite24:
	.db %11111011
	.db %11110011
	.db %11100011
	.db %11000011
	.db %00000011
	.db %11111111
	.db %11111111
	.db %00000000

;==================================
; Sprites   (For Game)
;==================================

Road:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

Side:
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111

Car:
	.db %00011000
	.db %01011010
	.db %01111110
	.db %01011010
	.db %00011000
	.db %11011011
	.db %11111111
	.db %11000011

.end
.end

;********** THAT'S IT!!!!! **********

;Special Thanks:
;Dan Eble for all his work.
;Matt Johnson for his 86 ASM tutorials.
;Trent Lillehaugen for his Frogger tutorial.
;And anyone else who helped me with my questions.
